<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: soa.php,v 1.7 2003/09/23 17:20:14 vollmerk Exp $
 $Source: /a1/cvsroot/maint/modules/class/soa.php,v $

 The SOA record object ... functions for manipulating & changing SOA
   records

*/

class SOA {
	var $id;
	var $domain; // this is a domain_id
	var $primary_master;
	var $hostmaster; // aka hostmaster
	var $refresh;
	var $retry;
	var $expire;
	var $delegated;
	var $ns_records;
	var $total_ns_records;
	var $ttl;
	var $object_history;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function SOA ( $soa_id = 0 ) {
		global $conf;

		$this->id = $soa_id;

		$info = $this->get_info();

		if ( ! $info ) {
			return false;
		}

		$this->domain         = new Domain($info->domain);
		$this->primary_master = $info->primary_master;
		$this->hostmaster     = $info->hostmaster;
		$this->refresh        = $info->refresh;
		$this->retry          = $info->retry;
		$this->expire         = $info->expire;
		$this->ttl            = $info->ttl;
		$this->delegated      = $info->delegated;

		// setup the NS records
		$this->ns_records       = $this->get_nameservers();
		$this->total_ns_records = $this->get_nameserver_count();
		
		// setup the object_history mojo
		$this->object_history 	= new ObjectHistory('soa',$this->id);
		
	} // NS

	function get_info () {
		global $conf;

		$sql = "SELECT * FROM soa WHERE id='$this->id'";
		$db_result = mysql_query($sql, $conf['dbh']);
		
		return mysql_fetch_object($db_result);
	} // get_info

	// Get an array of NS objects for this SOA
	function get_nameservers () {
		global $conf;

		$domain_id = $this->domain->id;
		$sql = "SELECT * FROM nameserver WHERE domain=$domain_id";
		$db_result = mysql_query($sql, $conf['dbh']);

		$ns_records = array();

		while ( $obj = mysql_fetch_object($db_result) ) {
			$ns_records[] = new NS($obj->id);
		}

		return $ns_records;
	}

	// return the total number of nameservers for this SOA
	function get_nameserver_count() {
		global $conf;

		$domain_id = $this->domain->id;
		$sql = "SELECT count(id) FROM nameserver WHERE domain='$domain_id'";
		$db_result = mysql_query($sql, $conf['dbh']);

		$count = mysql_fetch_row($db_result);
		return $count[0];
	}

	function insert_nameserver ($nameserver) {
		global $conf;

		$domain_id = $this->domain->id;
		$sql = "INSERT INTO nameserver (name,domain) VALUES ('$nameserver', $domain_id)";
		$db_result = mysql_query($sql, $conf['dbh']);

		return mysql_insert_id($conf['dbh']);
	}

	function delete_nameserver ($nameserver_id) {
	        global $conf;

                $sql = "DELETE FROM nameserver WHERE id='$nameserver_id'";
                $db_result = mysql_query($sql, $conf['dbh']);
	}

	function insert_glue($glue, $nameserver_id) {
		global $conf;

		$sql = "UPDATE nameserver SET glue=inet_aton('$glue') WHERE id=$nameserver_id";
                $db_result = mysql_query($sql, $conf['dbh']);
	}

	function update_domain ($domain) {
		$this->update_type('domain', $domain);
		$this->domain = $domain;
	}

	function update_primary_master ($primary_master) {
		$this->update_type('primary_master', $primary_master);
		$this->primary_master = $primary_master;
	}

	function update_hostmaster($hostmaster) {
		$this->update_type('hostmaster', $hostmaster);
		$this->hostmaster = $hostmaster;
	}

	function update_refresh($refresh) {
		$this->update_type('refresh', $refresh);
		$this->refresh = $refresh;
	}

	function update_retry($retry) {
		$this->update_type('retry', $retry);
		$this->retry = $retry;
	}

	function update_expire($expire) {
		$this->update_type('expire', $expire);
		$this->expire = $expire;
	}

	function update_ttl ($ttl) {
		$this->update_type('ttl', $ttl);
		$this->ttl = $ttl;
	}

	function update_type ($type, $value) {

		$sql = "UPDATE soa SET $type='$value' WHERE id='$this->id'";
		$db_result = mysql_query($sql, dbh());

	} // update_type

	function add_delegation () {
		$this->update_type('delegated', 'true');
		$this->delegated = true;
	}

	function remove_delegation () {
		$this->update_type('delegated', 'false');
		$this->delegated = false;
	}

	function create ($domain_id,$comment=0) {
		global $conf;

		$primary_master = $conf['soa_primary_master'];
		$hostmaster = $conf['soa_hostmaster'];
		$refresh = $conf['soa_refresh'];
		$retry = $conf['soa_retry'];
		$expire = $conf['soa_expire'];
		$ttl = $conf['soa_ttl'];

		$sql = "INSERT INTO soa (domain,primary_master,hostmaster,refresh,retry,expire,ttl) " .
			"VALUES ($domain_id, '$primary_master', '$hostmaster'," .
			"$refresh, $retry, $expire, $ttl)";

		$db_result = mysql_query($sql, $conf['dbh']);
		$soa_id = mysql_insert_id($conf['dbh']);

		$soa_object = new Soa($soa_id);
                if (!$comment) { $comment = "No Comment"; }
		$soa_object->object_history->update($user->username,$comment);
			
		return $soa_id;
	}

	function delete () {
		global $conf;

		$sql = "DELETE FROM soa WHERE id=$this->id";
		$db_result = mysql_query($sql, $conf['dbh']);
	}
}

?>
